﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2020.1.2),
    on Mon May 11 13:50:30 2020
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

from __future__ import absolute_import, division

from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle
import os  # handy system and path functions
import sys  # to get file system encoding

from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)

# Store info about the experiment session
psychopyVersion = '2020.1.2'
expName = 'inputText2'  # from the Builder filename that created this script
expInfo = {'participant': '', 'session': '001'}
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='/Users/mauromanassi/Google Drive/PSYCHOPY ILLUSION/Illusion3_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run before the window creation

# Setup the Window
win = visual.Window(
    size=[1920, 1080], fullscr=True, screen=0, 
    winType='pyglet', allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='height')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard()

# Initialize components for Routine "A_Start"
A_StartClock = core.Clock()
instText = visual.TextStim(win=win, name='instText',
    text='In this demo, we show how you can use text components to write a users keyboard input on screen.\n\nInstructions.\n\nPress spacebar to continue...',
    font='Arial',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
key_resp = keyboard.Keyboard()
VideoPath = 'Videos/FrameTEST2250.mp4'
thisExp.addData('VideoPath',VideoPath)

Code = randint(100, 1000)
thisExp.addData('SubjCode',Code)

End_string = "YOUR PERSONAL CODE IS: " + str(Code)

# Initialize components for Routine "B_Consent1"
B_Consent1Clock = core.Clock()
Background = visual.Rect(
    win=win, name='Background',units='height', 
    width=(2, 1)[0], height=(2, 1)[1],
    ori=0, pos=(0, 0),
    lineWidth=1, lineColor=[1,1,1], lineColorSpace='rgb',
    fillColor=[1.000,1.000,1.000], fillColorSpace='rgb',
    opacity=1, depth=0.0, interpolate=True)
ConsentForm1 = visual.ImageStim(
    win=win,
    name='ConsentForm1', units='height', 
    image='Images/consent1.jpg', mask=None,
    ori=0, pos=(0, 0), size=(1.4, 1),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-1.0)
Agree = visual.ImageStim(
    win=win,
    name='Agree', units='height', 
    image='Images/agree2.png', mask=None,
    ori=0, pos=(0.70, -0.45), size=(0.2, 0.1),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-2.0)
Disagree = visual.ImageStim(
    win=win,
    name='Disagree', units='height', 
    image='Images/disagree2.png', mask=None,
    ori=0, pos=(-0.70, -0.45), size=(0.2, 0.1),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-3.0)
Mouse1 = event.Mouse(win=win)
x, y = [None, None]
Mouse1.mouseClock = core.Clock()

# Initialize components for Routine "C_Consent2"
C_Consent2Clock = core.Clock()
ConsentForm2 = visual.ImageStim(
    win=win,
    name='ConsentForm2', units='height', 
    image='Images/consent2.jpg', mask=None,
    ori=0, pos=(0, 0), size=(1.4, 0.7),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)
Button2 = visual.ImageStim(
    win=win,
    name='Button2', units='height', 
    image='Images/button.png', mask=None,
    ori=0, pos=(0.65, -0.45), size=(0.1, 0.045),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-1.0)
Mouse2 = event.Mouse(win=win)
x, y = [None, None]
Mouse2.mouseClock = core.Clock()

# Initialize components for Routine "D_Consent3"
D_Consent3Clock = core.Clock()
ConsentForm3 = visual.ImageStim(
    win=win,
    name='ConsentForm3', units='height', 
    image='Images/consent3.jpg', mask=None,
    ori=0, pos=(0, 0), size=(1.4, 0.6),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)
Button_Agree = visual.ImageStim(
    win=win,
    name='Button_Agree', units='height', 
    image='Images/agree.png', mask=None,
    ori=0, pos=(-0.7, -0.45), size=(0.15, 0.045),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-1.0)
Button_Disagree = visual.ImageStim(
    win=win,
    name='Button_Disagree', units='height', 
    image='Images/disagree.png', mask=None,
    ori=0, pos=(0.7, -0.45), size=(0.15, 0.045),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-2.0)
Mouse3 = event.Mouse(win=win)
x, y = [None, None]
Mouse3.mouseClock = core.Clock()

# Initialize components for Routine "E_Video"
E_VideoClock = core.Clock()

# Initialize components for Routine "F_Response"
F_ResponseClock = core.Clock()
TextFrame = visual.Rect(
    win=win, name='TextFrame',units='height', 
    width=(0.5, 0.15)[0], height=(0.5, 0.15)[1],
    ori=0, pos=(0, 0),
    lineWidth=15, lineColor=[-1,-1,-1], lineColorSpace='rgb',
    fillColor=[0,0,0], fillColorSpace='rgb',
    opacity=1, depth=0.0, interpolate=True)
instr = visual.TextStim(win=win, name='instr',
    text='Type the answer in the frame below, \nand press RETURN\n(text will appear when you type)',
    font='Arial',
    units='norm', pos=(0, 0.5), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);
text = visual.TextStim(win=win, name='text',
    text=None,
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-2.0);

# Initialize components for Routine "G_End"
G_EndClock = core.Clock()
Thank_You = visual.TextStim(win=win, name='Thank_You',
    text='In order to complete the survey,\nplease send an email to mauromanassi@gmail.com\nwith your Name and Surname in the Subject,\nfollowed by the code below (in black):\n\n\n\n\n\n\n\nAfter you have sent the email, please click on the NEXT button for the Debrief form\n(or close the browser tab now)',
    font='Arial',
    units='height', pos=(0, 0), height=0.05, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
Text_Email = visual.TextStim(win=win, name='Text_Email',
    text=End_string,
    font='Arial',
    units='height', pos=(0, 0), height=0.05, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);
Mail_Example = visual.TextStim(win=win, name='Mail_Example',
    text='\n\n\n\n\n\n\n(Mail Subject Example: Mauro Manassi Code 568)\n',
    font='Arial',
    units='height', pos=(0, 0), height=0.04, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-2.0);
Button_End = visual.ImageStim(
    win=win,
    name='Button_End', units='height', 
    image='Images/button.png', mask=None,
    ori=0, pos=(0.65, -0.45), size=(0.1, 0.045),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-3.0)
Mouse_End = event.Mouse(win=win)
x, y = [None, None]
Mouse_End.mouseClock = core.Clock()

# Initialize components for Routine "H_Debrief1"
H_Debrief1Clock = core.Clock()
Debrief1 = visual.ImageStim(
    win=win,
    name='Debrief1', units='height', 
    image='Images/consent1.jpg', mask=None,
    ori=0, pos=(0, 0), size=(1.4, 1.0),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)
Button3 = visual.ImageStim(
    win=win,
    name='Button3', units='height', 
    image='Images/button.png', mask=None,
    ori=0, pos=(0.65, -0.45), size=(0.1, 0.045),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-1.0)
Mouse4 = event.Mouse(win=win)
x, y = [None, None]
Mouse4.mouseClock = core.Clock()

# Initialize components for Routine "I_Debrief2"
I_Debrief2Clock = core.Clock()
Debrief2 = visual.ImageStim(
    win=win,
    name='Debrief2', units='height', 
    image='Images/consent1.jpg', mask=None,
    ori=0, pos=(0, 0), size=(1.4, 0.7),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)
Button4 = visual.ImageStim(
    win=win,
    name='Button4', units='height', 
    image='Images/button.png', mask=None,
    ori=0, pos=(0.65, -0.45), size=(0.1, 0.045),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-1.0)
Mouse5 = event.Mouse(win=win)
x, y = [None, None]
Mouse5.mouseClock = core.Clock()

# Initialize components for Routine "J_Debrief3"
J_Debrief3Clock = core.Clock()
Debrief3 = visual.ImageStim(
    win=win,
    name='Debrief3', units='height', 
    image='Images/consent3.jpg', mask=None,
    ori=0, pos=(0, 0), size=(1.4, 0.6),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)
Mouse6 = event.Mouse(win=win)
x, y = [None, None]
Mouse6.mouseClock = core.Clock()
text_3 = visual.TextStim(win=win, name='text_3',
    text='Thank you for participating!\n(You can close the browser now)',
    font='Arial',
    units='height', pos=(0, -0.4), height=0.05, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-2.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "A_Start"-------
continueRoutine = True
# update component parameters for each repeat
key_resp.keys = []
key_resp.rt = []
_key_resp_allKeys = []
# keep track of which components have finished
A_StartComponents = [instText, key_resp]
for thisComponent in A_StartComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
A_StartClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "A_Start"-------
while continueRoutine:
    # get current time
    t = A_StartClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=A_StartClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *instText* updates
    if instText.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        instText.frameNStart = frameN  # exact frame index
        instText.tStart = t  # local t and not account for scr refresh
        instText.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(instText, 'tStartRefresh')  # time at next scr refresh
        instText.setAutoDraw(True)
    
    # *key_resp* updates
    waitOnFlip = False
    if key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        key_resp.frameNStart = frameN  # exact frame index
        key_resp.tStart = t  # local t and not account for scr refresh
        key_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_resp, 'tStartRefresh')  # time at next scr refresh
        key_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_resp.status == STARTED and not waitOnFlip:
        theseKeys = key_resp.getKeys(keyList=['space'], waitRelease=False)
        _key_resp_allKeys.extend(theseKeys)
        if len(_key_resp_allKeys):
            key_resp.keys = _key_resp_allKeys[-1].name  # just the last key pressed
            key_resp.rt = _key_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in A_StartComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "A_Start"-------
for thisComponent in A_StartComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('instText.started', instText.tStartRefresh)
thisExp.addData('instText.stopped', instText.tStopRefresh)
# check responses
if key_resp.keys in ['', [], None]:  # No response was made
    key_resp.keys = None
thisExp.addData('key_resp.keys',key_resp.keys)
if key_resp.keys != None:  # we had a response
    thisExp.addData('key_resp.rt', key_resp.rt)
thisExp.addData('key_resp.started', key_resp.tStartRefresh)
thisExp.addData('key_resp.stopped', key_resp.tStopRefresh)
thisExp.nextEntry()
# the Routine "A_Start" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "B_Consent1"-------
continueRoutine = True
# update component parameters for each repeat
# setup some python lists for storing info about the Mouse1
Mouse1.clicked_name = []
gotValidClick = False  # until a click is received
# keep track of which components have finished
B_Consent1Components = [Background, ConsentForm1, Agree, Disagree, Mouse1]
for thisComponent in B_Consent1Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
B_Consent1Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "B_Consent1"-------
while continueRoutine:
    # get current time
    t = B_Consent1Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=B_Consent1Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *Background* updates
    if Background.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Background.frameNStart = frameN  # exact frame index
        Background.tStart = t  # local t and not account for scr refresh
        Background.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Background, 'tStartRefresh')  # time at next scr refresh
        Background.setAutoDraw(True)
    
    # *ConsentForm1* updates
    if ConsentForm1.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        ConsentForm1.frameNStart = frameN  # exact frame index
        ConsentForm1.tStart = t  # local t and not account for scr refresh
        ConsentForm1.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(ConsentForm1, 'tStartRefresh')  # time at next scr refresh
        ConsentForm1.setAutoDraw(True)
    
    # *Agree* updates
    if Agree.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Agree.frameNStart = frameN  # exact frame index
        Agree.tStart = t  # local t and not account for scr refresh
        Agree.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Agree, 'tStartRefresh')  # time at next scr refresh
        Agree.setAutoDraw(True)
    
    # *Disagree* updates
    if Disagree.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Disagree.frameNStart = frameN  # exact frame index
        Disagree.tStart = t  # local t and not account for scr refresh
        Disagree.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Disagree, 'tStartRefresh')  # time at next scr refresh
        Disagree.setAutoDraw(True)
    # *Mouse1* updates
    if Mouse1.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Mouse1.frameNStart = frameN  # exact frame index
        Mouse1.tStart = t  # local t and not account for scr refresh
        Mouse1.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Mouse1, 'tStartRefresh')  # time at next scr refresh
        Mouse1.status = STARTED
        Mouse1.mouseClock.reset()
        prevButtonState = Mouse1.getPressed()  # if button is down already this ISN'T a new click
    if Mouse1.status == STARTED:  # only update if started and not finished!
        buttons = Mouse1.getPressed()
        if buttons != prevButtonState:  # button state changed?
            prevButtonState = buttons
            if sum(buttons) > 0:  # state changed to a new click
                # check if the mouse was inside our 'clickable' objects
                gotValidClick = False
                for obj in [Agree]:
                    if obj.contains(Mouse1):
                        gotValidClick = True
                        Mouse1.clicked_name.append(obj.name)
                if gotValidClick:  # abort routine on response
                    continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in B_Consent1Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "B_Consent1"-------
for thisComponent in B_Consent1Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('Background.started', Background.tStartRefresh)
thisExp.addData('Background.stopped', Background.tStopRefresh)
thisExp.addData('ConsentForm1.started', ConsentForm1.tStartRefresh)
thisExp.addData('ConsentForm1.stopped', ConsentForm1.tStopRefresh)
thisExp.addData('Agree.started', Agree.tStartRefresh)
thisExp.addData('Agree.stopped', Agree.tStopRefresh)
thisExp.addData('Disagree.started', Disagree.tStartRefresh)
thisExp.addData('Disagree.stopped', Disagree.tStopRefresh)
# store data for thisExp (ExperimentHandler)
x, y = Mouse1.getPos()
buttons = Mouse1.getPressed()
if sum(buttons):
    # check if the mouse was inside our 'clickable' objects
    gotValidClick = False
    for obj in [Agree]:
        if obj.contains(Mouse1):
            gotValidClick = True
            Mouse1.clicked_name.append(obj.name)
thisExp.addData('Mouse1.x', x)
thisExp.addData('Mouse1.y', y)
thisExp.addData('Mouse1.leftButton', buttons[0])
thisExp.addData('Mouse1.midButton', buttons[1])
thisExp.addData('Mouse1.rightButton', buttons[2])
if len(Mouse1.clicked_name):
    thisExp.addData('Mouse1.clicked_name', Mouse1.clicked_name[0])
thisExp.addData('Mouse1.started', Mouse1.tStart)
thisExp.addData('Mouse1.stopped', Mouse1.tStop)
thisExp.nextEntry()
# the Routine "B_Consent1" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "C_Consent2"-------
continueRoutine = True
# update component parameters for each repeat
# setup some python lists for storing info about the Mouse2
Mouse2.clicked_name = []
gotValidClick = False  # until a click is received
# keep track of which components have finished
C_Consent2Components = [ConsentForm2, Button2, Mouse2]
for thisComponent in C_Consent2Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
C_Consent2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "C_Consent2"-------
while continueRoutine:
    # get current time
    t = C_Consent2Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=C_Consent2Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *ConsentForm2* updates
    if ConsentForm2.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        ConsentForm2.frameNStart = frameN  # exact frame index
        ConsentForm2.tStart = t  # local t and not account for scr refresh
        ConsentForm2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(ConsentForm2, 'tStartRefresh')  # time at next scr refresh
        ConsentForm2.setAutoDraw(True)
    
    # *Button2* updates
    if Button2.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Button2.frameNStart = frameN  # exact frame index
        Button2.tStart = t  # local t and not account for scr refresh
        Button2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Button2, 'tStartRefresh')  # time at next scr refresh
        Button2.setAutoDraw(True)
    # *Mouse2* updates
    if Mouse2.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Mouse2.frameNStart = frameN  # exact frame index
        Mouse2.tStart = t  # local t and not account for scr refresh
        Mouse2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Mouse2, 'tStartRefresh')  # time at next scr refresh
        Mouse2.status = STARTED
        Mouse2.mouseClock.reset()
        prevButtonState = Mouse2.getPressed()  # if button is down already this ISN'T a new click
    if Mouse2.status == STARTED:  # only update if started and not finished!
        buttons = Mouse2.getPressed()
        if buttons != prevButtonState:  # button state changed?
            prevButtonState = buttons
            if sum(buttons) > 0:  # state changed to a new click
                # check if the mouse was inside our 'clickable' objects
                gotValidClick = False
                for obj in [Button2]:
                    if obj.contains(Mouse2):
                        gotValidClick = True
                        Mouse2.clicked_name.append(obj.name)
                if gotValidClick:  # abort routine on response
                    continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in C_Consent2Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "C_Consent2"-------
for thisComponent in C_Consent2Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('ConsentForm2.started', ConsentForm2.tStartRefresh)
thisExp.addData('ConsentForm2.stopped', ConsentForm2.tStopRefresh)
thisExp.addData('Button2.started', Button2.tStartRefresh)
thisExp.addData('Button2.stopped', Button2.tStopRefresh)
# store data for thisExp (ExperimentHandler)
thisExp.addData('Mouse2.started', Mouse2.tStart)
thisExp.addData('Mouse2.stopped', Mouse2.tStop)
thisExp.nextEntry()
# the Routine "C_Consent2" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "D_Consent3"-------
continueRoutine = True
# update component parameters for each repeat
# setup some python lists for storing info about the Mouse3
Mouse3.clicked_name = []
gotValidClick = False  # until a click is received
# keep track of which components have finished
D_Consent3Components = [ConsentForm3, Button_Agree, Button_Disagree, Mouse3]
for thisComponent in D_Consent3Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
D_Consent3Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "D_Consent3"-------
while continueRoutine:
    # get current time
    t = D_Consent3Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=D_Consent3Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *ConsentForm3* updates
    if ConsentForm3.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        ConsentForm3.frameNStart = frameN  # exact frame index
        ConsentForm3.tStart = t  # local t and not account for scr refresh
        ConsentForm3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(ConsentForm3, 'tStartRefresh')  # time at next scr refresh
        ConsentForm3.setAutoDraw(True)
    
    # *Button_Agree* updates
    if Button_Agree.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Button_Agree.frameNStart = frameN  # exact frame index
        Button_Agree.tStart = t  # local t and not account for scr refresh
        Button_Agree.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Button_Agree, 'tStartRefresh')  # time at next scr refresh
        Button_Agree.setAutoDraw(True)
    
    # *Button_Disagree* updates
    if Button_Disagree.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Button_Disagree.frameNStart = frameN  # exact frame index
        Button_Disagree.tStart = t  # local t and not account for scr refresh
        Button_Disagree.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Button_Disagree, 'tStartRefresh')  # time at next scr refresh
        Button_Disagree.setAutoDraw(True)
    # *Mouse3* updates
    if Mouse3.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Mouse3.frameNStart = frameN  # exact frame index
        Mouse3.tStart = t  # local t and not account for scr refresh
        Mouse3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Mouse3, 'tStartRefresh')  # time at next scr refresh
        Mouse3.status = STARTED
        Mouse3.mouseClock.reset()
        prevButtonState = Mouse3.getPressed()  # if button is down already this ISN'T a new click
    if Mouse3.status == STARTED:  # only update if started and not finished!
        buttons = Mouse3.getPressed()
        if buttons != prevButtonState:  # button state changed?
            prevButtonState = buttons
            if sum(buttons) > 0:  # state changed to a new click
                # check if the mouse was inside our 'clickable' objects
                gotValidClick = False
                for obj in [Button_Agree]:
                    if obj.contains(Mouse3):
                        gotValidClick = True
                        Mouse3.clicked_name.append(obj.name)
                if gotValidClick:  # abort routine on response
                    continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in D_Consent3Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "D_Consent3"-------
for thisComponent in D_Consent3Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('ConsentForm3.started', ConsentForm3.tStartRefresh)
thisExp.addData('ConsentForm3.stopped', ConsentForm3.tStopRefresh)
thisExp.addData('Button_Agree.started', Button_Agree.tStartRefresh)
thisExp.addData('Button_Agree.stopped', Button_Agree.tStopRefresh)
thisExp.addData('Button_Disagree.started', Button_Disagree.tStartRefresh)
thisExp.addData('Button_Disagree.stopped', Button_Disagree.tStopRefresh)
# store data for thisExp (ExperimentHandler)
thisExp.addData('Mouse3.started', Mouse3.tStart)
thisExp.addData('Mouse3.stopped', Mouse3.tStop)
thisExp.nextEntry()
# the Routine "D_Consent3" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "E_Video"-------
continueRoutine = True
# update component parameters for each repeat
# keep track of which components have finished
E_VideoComponents = []
for thisComponent in E_VideoComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
E_VideoClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "E_Video"-------
while continueRoutine:
    # get current time
    t = E_VideoClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=E_VideoClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in E_VideoComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "E_Video"-------
for thisComponent in E_VideoComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "E_Video" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
trials = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='trials')
thisExp.addLoop(trials)  # add the loop to the experiment
thisTrial = trials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
if thisTrial != None:
    for paramName in thisTrial:
        exec('{} = thisTrial[paramName]'.format(paramName))

for thisTrial in trials:
    currentLoop = trials
    # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
    if thisTrial != None:
        for paramName in thisTrial:
            exec('{} = thisTrial[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "F_Response"-------
    continueRoutine = True
    # update component parameters for each repeat
    modify = False
    text.text = ''
    event.clearEvents('keyboard')
    # keep track of which components have finished
    F_ResponseComponents = [TextFrame, instr, text]
    for thisComponent in F_ResponseComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    F_ResponseClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "F_Response"-------
    while continueRoutine:
        # get current time
        t = F_ResponseClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=F_ResponseClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *TextFrame* updates
        if TextFrame.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            TextFrame.frameNStart = frameN  # exact frame index
            TextFrame.tStart = t  # local t and not account for scr refresh
            TextFrame.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(TextFrame, 'tStartRefresh')  # time at next scr refresh
            TextFrame.setAutoDraw(True)
        
        # *instr* updates
        if instr.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            instr.frameNStart = frameN  # exact frame index
            instr.tStart = t  # local t and not account for scr refresh
            instr.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(instr, 'tStartRefresh')  # time at next scr refresh
            instr.setAutoDraw(True)
        
        # *text* updates
        if text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text.frameNStart = frameN  # exact frame index
            text.tStart = t  # local t and not account for scr refresh
            text.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text, 'tStartRefresh')  # time at next scr refresh
            text.setAutoDraw(True)
        keys = event.getKeys()
        if len(keys):
            if 'space' in keys:
                text.text = text.text + ' '
            elif 'backspace' in keys:
                text.text = text.text[:-1]
            elif 'lshift' in keys or 'rshift' in keys:
                modify = True
            elif 'return' in keys:
                continueRoutine = False
            else:
                if modify:
                    text.text = text.text + keys[0].upper()
                    modify = False
                else:
                    text.text = text.text + keys[0]
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in F_ResponseComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "F_Response"-------
    for thisComponent in F_ResponseComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    trials.addData('TextFrame.started', TextFrame.tStartRefresh)
    trials.addData('TextFrame.stopped', TextFrame.tStopRefresh)
    trials.addData('instr.started', instr.tStartRefresh)
    trials.addData('instr.stopped', instr.tStopRefresh)
    trials.addData('text.started', text.tStartRefresh)
    trials.addData('text.stopped', text.tStopRefresh)
    thisExp.addData("typedWord", text.text)
    # the Routine "F_Response" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 1 repeats of 'trials'


# ------Prepare to start Routine "G_End"-------
continueRoutine = True
# update component parameters for each repeat
# setup some python lists for storing info about the Mouse_End
Mouse_End.clicked_name = []
gotValidClick = False  # until a click is received
# keep track of which components have finished
G_EndComponents = [Thank_You, Text_Email, Mail_Example, Button_End, Mouse_End]
for thisComponent in G_EndComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
G_EndClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "G_End"-------
while continueRoutine:
    # get current time
    t = G_EndClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=G_EndClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *Thank_You* updates
    if Thank_You.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        Thank_You.frameNStart = frameN  # exact frame index
        Thank_You.tStart = t  # local t and not account for scr refresh
        Thank_You.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Thank_You, 'tStartRefresh')  # time at next scr refresh
        Thank_You.setAutoDraw(True)
    
    # *Text_Email* updates
    if Text_Email.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Text_Email.frameNStart = frameN  # exact frame index
        Text_Email.tStart = t  # local t and not account for scr refresh
        Text_Email.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Text_Email, 'tStartRefresh')  # time at next scr refresh
        Text_Email.setAutoDraw(True)
    
    # *Mail_Example* updates
    if Mail_Example.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Mail_Example.frameNStart = frameN  # exact frame index
        Mail_Example.tStart = t  # local t and not account for scr refresh
        Mail_Example.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Mail_Example, 'tStartRefresh')  # time at next scr refresh
        Mail_Example.setAutoDraw(True)
    
    # *Button_End* updates
    if Button_End.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Button_End.frameNStart = frameN  # exact frame index
        Button_End.tStart = t  # local t and not account for scr refresh
        Button_End.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Button_End, 'tStartRefresh')  # time at next scr refresh
        Button_End.setAutoDraw(True)
    # *Mouse_End* updates
    if Mouse_End.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Mouse_End.frameNStart = frameN  # exact frame index
        Mouse_End.tStart = t  # local t and not account for scr refresh
        Mouse_End.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Mouse_End, 'tStartRefresh')  # time at next scr refresh
        Mouse_End.status = STARTED
        Mouse_End.mouseClock.reset()
        prevButtonState = Mouse_End.getPressed()  # if button is down already this ISN'T a new click
    if Mouse_End.status == STARTED:  # only update if started and not finished!
        buttons = Mouse_End.getPressed()
        if buttons != prevButtonState:  # button state changed?
            prevButtonState = buttons
            if sum(buttons) > 0:  # state changed to a new click
                # check if the mouse was inside our 'clickable' objects
                gotValidClick = False
                for obj in [Button_End]:
                    if obj.contains(Mouse_End):
                        gotValidClick = True
                        Mouse_End.clicked_name.append(obj.name)
                if gotValidClick:  # abort routine on response
                    continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in G_EndComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "G_End"-------
for thisComponent in G_EndComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('Thank_You.started', Thank_You.tStartRefresh)
thisExp.addData('Thank_You.stopped', Thank_You.tStopRefresh)
thisExp.addData('Text_Email.started', Text_Email.tStartRefresh)
thisExp.addData('Text_Email.stopped', Text_Email.tStopRefresh)
thisExp.addData('Mail_Example.started', Mail_Example.tStartRefresh)
thisExp.addData('Mail_Example.stopped', Mail_Example.tStopRefresh)
thisExp.addData('Button_End.started', Button_End.tStartRefresh)
thisExp.addData('Button_End.stopped', Button_End.tStopRefresh)
# store data for thisExp (ExperimentHandler)
x, y = Mouse_End.getPos()
buttons = Mouse_End.getPressed()
if sum(buttons):
    # check if the mouse was inside our 'clickable' objects
    gotValidClick = False
    for obj in [Button_End]:
        if obj.contains(Mouse_End):
            gotValidClick = True
            Mouse_End.clicked_name.append(obj.name)
thisExp.addData('Mouse_End.x', x)
thisExp.addData('Mouse_End.y', y)
thisExp.addData('Mouse_End.leftButton', buttons[0])
thisExp.addData('Mouse_End.midButton', buttons[1])
thisExp.addData('Mouse_End.rightButton', buttons[2])
if len(Mouse_End.clicked_name):
    thisExp.addData('Mouse_End.clicked_name', Mouse_End.clicked_name[0])
thisExp.addData('Mouse_End.started', Mouse_End.tStart)
thisExp.addData('Mouse_End.stopped', Mouse_End.tStop)
thisExp.nextEntry()
# the Routine "G_End" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "H_Debrief1"-------
continueRoutine = True
# update component parameters for each repeat
# setup some python lists for storing info about the Mouse4
Mouse4.clicked_name = []
gotValidClick = False  # until a click is received
# keep track of which components have finished
H_Debrief1Components = [Debrief1, Button3, Mouse4]
for thisComponent in H_Debrief1Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
H_Debrief1Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "H_Debrief1"-------
while continueRoutine:
    # get current time
    t = H_Debrief1Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=H_Debrief1Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *Debrief1* updates
    if Debrief1.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Debrief1.frameNStart = frameN  # exact frame index
        Debrief1.tStart = t  # local t and not account for scr refresh
        Debrief1.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Debrief1, 'tStartRefresh')  # time at next scr refresh
        Debrief1.setAutoDraw(True)
    
    # *Button3* updates
    if Button3.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Button3.frameNStart = frameN  # exact frame index
        Button3.tStart = t  # local t and not account for scr refresh
        Button3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Button3, 'tStartRefresh')  # time at next scr refresh
        Button3.setAutoDraw(True)
    # *Mouse4* updates
    if Mouse4.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Mouse4.frameNStart = frameN  # exact frame index
        Mouse4.tStart = t  # local t and not account for scr refresh
        Mouse4.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Mouse4, 'tStartRefresh')  # time at next scr refresh
        Mouse4.status = STARTED
        Mouse4.mouseClock.reset()
        prevButtonState = Mouse4.getPressed()  # if button is down already this ISN'T a new click
    if Mouse4.status == STARTED:  # only update if started and not finished!
        buttons = Mouse4.getPressed()
        if buttons != prevButtonState:  # button state changed?
            prevButtonState = buttons
            if sum(buttons) > 0:  # state changed to a new click
                # check if the mouse was inside our 'clickable' objects
                gotValidClick = False
                for obj in [Button3]:
                    if obj.contains(Mouse4):
                        gotValidClick = True
                        Mouse4.clicked_name.append(obj.name)
                if gotValidClick:  # abort routine on response
                    continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in H_Debrief1Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "H_Debrief1"-------
for thisComponent in H_Debrief1Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('Debrief1.started', Debrief1.tStartRefresh)
thisExp.addData('Debrief1.stopped', Debrief1.tStopRefresh)
thisExp.addData('Button3.started', Button3.tStartRefresh)
thisExp.addData('Button3.stopped', Button3.tStopRefresh)
# store data for thisExp (ExperimentHandler)
x, y = Mouse4.getPos()
buttons = Mouse4.getPressed()
if sum(buttons):
    # check if the mouse was inside our 'clickable' objects
    gotValidClick = False
    for obj in [Button3]:
        if obj.contains(Mouse4):
            gotValidClick = True
            Mouse4.clicked_name.append(obj.name)
thisExp.addData('Mouse4.x', x)
thisExp.addData('Mouse4.y', y)
thisExp.addData('Mouse4.leftButton', buttons[0])
thisExp.addData('Mouse4.midButton', buttons[1])
thisExp.addData('Mouse4.rightButton', buttons[2])
if len(Mouse4.clicked_name):
    thisExp.addData('Mouse4.clicked_name', Mouse4.clicked_name[0])
thisExp.addData('Mouse4.started', Mouse4.tStart)
thisExp.addData('Mouse4.stopped', Mouse4.tStop)
thisExp.nextEntry()
# the Routine "H_Debrief1" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "I_Debrief2"-------
continueRoutine = True
# update component parameters for each repeat
# setup some python lists for storing info about the Mouse5
Mouse5.clicked_name = []
gotValidClick = False  # until a click is received
# keep track of which components have finished
I_Debrief2Components = [Debrief2, Button4, Mouse5]
for thisComponent in I_Debrief2Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
I_Debrief2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "I_Debrief2"-------
while continueRoutine:
    # get current time
    t = I_Debrief2Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=I_Debrief2Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *Debrief2* updates
    if Debrief2.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Debrief2.frameNStart = frameN  # exact frame index
        Debrief2.tStart = t  # local t and not account for scr refresh
        Debrief2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Debrief2, 'tStartRefresh')  # time at next scr refresh
        Debrief2.setAutoDraw(True)
    
    # *Button4* updates
    if Button4.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Button4.frameNStart = frameN  # exact frame index
        Button4.tStart = t  # local t and not account for scr refresh
        Button4.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Button4, 'tStartRefresh')  # time at next scr refresh
        Button4.setAutoDraw(True)
    # *Mouse5* updates
    if Mouse5.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Mouse5.frameNStart = frameN  # exact frame index
        Mouse5.tStart = t  # local t and not account for scr refresh
        Mouse5.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Mouse5, 'tStartRefresh')  # time at next scr refresh
        Mouse5.status = STARTED
        Mouse5.mouseClock.reset()
        prevButtonState = Mouse5.getPressed()  # if button is down already this ISN'T a new click
    if Mouse5.status == STARTED:  # only update if started and not finished!
        buttons = Mouse5.getPressed()
        if buttons != prevButtonState:  # button state changed?
            prevButtonState = buttons
            if sum(buttons) > 0:  # state changed to a new click
                # check if the mouse was inside our 'clickable' objects
                gotValidClick = False
                for obj in [Button4]:
                    if obj.contains(Mouse5):
                        gotValidClick = True
                        Mouse5.clicked_name.append(obj.name)
                if gotValidClick:  # abort routine on response
                    continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in I_Debrief2Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "I_Debrief2"-------
for thisComponent in I_Debrief2Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('Debrief2.started', Debrief2.tStartRefresh)
thisExp.addData('Debrief2.stopped', Debrief2.tStopRefresh)
thisExp.addData('Button4.started', Button4.tStartRefresh)
thisExp.addData('Button4.stopped', Button4.tStopRefresh)
# store data for thisExp (ExperimentHandler)
x, y = Mouse5.getPos()
buttons = Mouse5.getPressed()
if sum(buttons):
    # check if the mouse was inside our 'clickable' objects
    gotValidClick = False
    for obj in [Button4]:
        if obj.contains(Mouse5):
            gotValidClick = True
            Mouse5.clicked_name.append(obj.name)
thisExp.addData('Mouse5.x', x)
thisExp.addData('Mouse5.y', y)
thisExp.addData('Mouse5.leftButton', buttons[0])
thisExp.addData('Mouse5.midButton', buttons[1])
thisExp.addData('Mouse5.rightButton', buttons[2])
if len(Mouse5.clicked_name):
    thisExp.addData('Mouse5.clicked_name', Mouse5.clicked_name[0])
thisExp.addData('Mouse5.started', Mouse5.tStart)
thisExp.addData('Mouse5.stopped', Mouse5.tStop)
thisExp.nextEntry()
# the Routine "I_Debrief2" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "J_Debrief3"-------
continueRoutine = True
# update component parameters for each repeat
# setup some python lists for storing info about the Mouse6
gotValidClick = False  # until a click is received
# keep track of which components have finished
J_Debrief3Components = [Debrief3, Mouse6, text_3]
for thisComponent in J_Debrief3Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
J_Debrief3Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "J_Debrief3"-------
while continueRoutine:
    # get current time
    t = J_Debrief3Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=J_Debrief3Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *Debrief3* updates
    if Debrief3.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Debrief3.frameNStart = frameN  # exact frame index
        Debrief3.tStart = t  # local t and not account for scr refresh
        Debrief3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Debrief3, 'tStartRefresh')  # time at next scr refresh
        Debrief3.setAutoDraw(True)
    # *Mouse6* updates
    if Mouse6.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Mouse6.frameNStart = frameN  # exact frame index
        Mouse6.tStart = t  # local t and not account for scr refresh
        Mouse6.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Mouse6, 'tStartRefresh')  # time at next scr refresh
        Mouse6.status = STARTED
        Mouse6.mouseClock.reset()
        prevButtonState = Mouse6.getPressed()  # if button is down already this ISN'T a new click
    if Mouse6.status == STARTED:  # only update if started and not finished!
        buttons = Mouse6.getPressed()
        if buttons != prevButtonState:  # button state changed?
            prevButtonState = buttons
            if sum(buttons) > 0:  # state changed to a new click
                # abort routine on response
                continueRoutine = False
    
    # *text_3* updates
    if text_3.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text_3.frameNStart = frameN  # exact frame index
        text_3.tStart = t  # local t and not account for scr refresh
        text_3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text_3, 'tStartRefresh')  # time at next scr refresh
        text_3.setAutoDraw(True)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in J_Debrief3Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "J_Debrief3"-------
for thisComponent in J_Debrief3Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('Debrief3.started', Debrief3.tStartRefresh)
thisExp.addData('Debrief3.stopped', Debrief3.tStopRefresh)
# store data for thisExp (ExperimentHandler)
x, y = Mouse6.getPos()
buttons = Mouse6.getPressed()
thisExp.addData('Mouse6.x', x)
thisExp.addData('Mouse6.y', y)
thisExp.addData('Mouse6.leftButton', buttons[0])
thisExp.addData('Mouse6.midButton', buttons[1])
thisExp.addData('Mouse6.rightButton', buttons[2])
thisExp.addData('Mouse6.started', Mouse6.tStart)
thisExp.addData('Mouse6.stopped', Mouse6.tStop)
thisExp.nextEntry()
thisExp.addData('text_3.started', text_3.tStartRefresh)
thisExp.addData('text_3.stopped', text_3.tStopRefresh)
# the Routine "J_Debrief3" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
